array byte receiveBuffer[64]
array byte transmitBuffer[64]
array byte deviceNames[100]
array byte deviceParameterCounts[6]
array byte deviceParameterVersionNumbers[6]
array deviceTimeouts[6]
array byte parameterFetched[22]

array byte ParameterBuffer[240]
array byte ParameterName[30]
array byte ParameterOptions[100]
array byte Line[22]
array byte deviceIds[6]

const STATE_DEVICE_LIST 0
const STATE_DEVICE_SETUP 1

const DEVICE_ID_BROADCAST 0
const DEVICE_ID_RADIO_TX 0xEA

const FRAME_POLL_DEVICES 0x28
const FRAME_DEVICE_INFO 0x29
const FRAME_PARAMETER_INFO 0x2B
const FRAME_POLL_PARAMETERS 0x2C
const FRAME_SET_PARAMETER 0x2D
const SEND_FAIL_TIMEOUT 10
const kMaxDeviceCount 6

if init = 0
  init = 1

  deviceIndex = 0
  deviceCount = 0

  responseTimeout = 0
  waitForResponse = 0

rem    menuItemCount = 0
rem    menuItemIndex = 0

  parameterIndex = 0
rem    parameterEdit = 0

  currentFolder = 0

  pktsRead = 0
  pktsSent = 0
rem    pktsGood = 0
rem    pktsWrongDev = 0
rem    pktsWrongParam = 0

rem    STATE_RUN_COMMAND = 2

  state = STATE_DEVICE_LIST

rem    TYPE_SELECT = 9
rem    TYPE_FOLDER = 11
rem    TYPE_INFO = 12
rem    TYPE_COMMAND = 13

rem    COMMAND_STATUS_READY = 0
rem    COMMAND_STATUS_START = 1
rem    COMMAND_STATUS_PROGRESS = 2
rem    COMMAND_STATUS_PLS_CONFIRM = 3
rem    COMMAND_STATUS_CONFIRM = 4
rem    COMMAND_STATUS_CANCEL = 5
rem    COMMAND_STATUS_POLL = 6

rem    DEVICE_TIMEOUT = 300
rem    PARAMETER_TIMEOUT = 20
rem    PARAMETER_REFETCH_TIMEOUT = 300
rem    SET_PARAMETER_TIMEOUT = 100

    rem -- including terminating zero
    rem -- @todo should be 45 according to spec, change later
  kMaxDeviceNameLength = 16
    rem -- dictated by the number of device names we could fit, will be raised later
rem    kMaxParameterNameLength = 14
  kMaxParameterCount = 16
rem    kMaxMenuItems = 16

  ParameterToRead = 0
	ParameterChunkIndex = 0
	ParameterBufferIndex = 0
  ReadingParameter = 0
  ParameterType = 0
  ParameterValue = 0
  ParameterMin = 0
  ParameterMax = 0
	Editing = 0
	if LCD_W > 220
	  FH = 32
		FW = 24
		EVT_MENU_BREAK = EVT_BTN_BREAK
	else
	  FH = 8
		FW = 6
	end

    rem -- purge the crossfire packet fifo
  result = crossfirereceive(count, command, receiveBuffer)
  while result = 1
    result = crossfirereceive(count, command, receiveBuffer)
  end

  gosub requestDeviceData
end

goto main

sendPacket:
  result = crossfiresend(sendCommand, sendLength, transmitBuffer)
  if result = 1
    pktsSent += 1
    responseTimeout = time + sendTimeout
  else
    responseTimeout = time + SEND_FAIL_TIMEOUT
  end
  return

requestDeviceData:
  transmitBuffer[0] = DEVICE_ID_BROADCAST
  transmitBuffer[1] = DEVICE_ID_RADIO_TX
  sendCommand = FRAME_POLL_DEVICES
  sendLength = 2
  waitForResponse = 0
  responseTimeout = 0
  gosub sendPacket
return

readParameter:
  transmitBuffer[0] = deviceIds[deviceIndex]
  transmitBuffer[1] = 0xEF
rem DEVICE_ID_RADIO_TX
  transmitBuffer[2] = ParameterToRead
  transmitBuffer[3] = ParameterChunkIndex
  sendCommand = FRAME_POLL_PARAMETERS
  sendLength = 4
  sendTimeout = PARAMETER_TIMEOUT
  waitForResponse = 1
  gosub sendPacket
return

sendNextPacket:
  rem -- if we're waiting for a response, retransmit the previous
  rem -- packet after a timeout
  if waitForResponse = 1 & responseTimeout > 0
    if time > responseTimeout
      gosub sendPacket
    end
    return
  end

  rem -- should we refresh any parameters?
  rem -- don't bother if we're in the device list page
  i = 0
rem   while i < kMaxParameterCount & i < deviceParameterCounts[deviceIndex] & state != STATE_DEVICE_LIST

rem  if parameterFetched[i] = 0
rem    gosub requestParameterData
		
		
		
rem		while i < kMaxParameterCount & i < 12 & state != STATE_DEVICE_LIST
rem      rem -- if (parameterFetched[i] = 0) | (time > parameterNextFetch[i])
rem      if (parameterFetched[i] = 0) | (time > parameterNextFetch[i])
rem          requestParameter = i + 1
rem          requestChunk = 0
rem          gosub requestParameterData
rem          return
rem      end
rem      i += 1
  end
return

parseDeviceInfo:
  rem  payload format:
  rem  uint8_t Destination node address
  rem  uint8_t Device node address
  rem  char[] Device name ( Null-terminated string )
  rem  uint32_t Serial number
  rem  uint32_t Hardware ID
  rem  uint32_t Firmware ID
  rem  uint8_t Parameters count
  rem  uint8_t Parameter version number

rem EA2229EAEE56616E746163204C6974652032473400454C5253000000000000000015009F

  id = receiveBuffer[1]
  index = 0

  while (index < deviceCount) & (id # deviceIds[index])
    index += 1
  end

    rem -- add new device
  if index = deviceCount
    if deviceCount < kMaxDeviceCount
  rem -- device fits
       deviceCount += 1
    else
  rem -- have to evict one of the devices to fit
      index -= 1
    end
  end

rem    rem -- fill device entry
  deviceIds[index] = id

  nameOffset = kMaxDeviceNameLength * index
rem    rem -- copy device name string
  i = 0
  while (receiveBuffer[i + 2] != 0) & (i < kMaxDeviceNameLength - 1)
    deviceNames[nameOffset + i] = receiveBuffer[i + 2]
    i += 1
  end

    rem -- add terminating zero
  deviceNames[nameOffset + i] = 0
  deviceParameterCounts[index] = receiveBuffer[i + 15]
  deviceParameterVersionNumbers[index] = receiveBuffer[i + 16]

  deviceTimeouts[index] = gettime() + DEVICE_TIMEOUT

return


checkForPackets:
  command = 0
  count = 0

  result = crossfirereceive(count, command, receiveBuffer)

  while result = 1
    pktsRead += 1
    if command = FRAME_DEVICE_INFO
      pktsGood += 1
      gosub parseDeviceInfo
    end
    if command = FRAME_PARAMETER_INFO
      gosub parseParameterPacket
    end
    result = crossfirereceive(count, command, receiveBuffer)
  end

return

displayParameter:
  drawtext(0, 0, "Parameter")
  drawnumber( 18*FW, 0, ParameterToRead )
rem  if ParameterValid = 1
    drawtext(0, FH, "Type")
    drawnumber( 13*FW, FH, ParameterType & 0x7F )
    drawtext(0, 2*FH, "Name")
    drawtext(5*FW, 2*FH, ParameterName)
		if ParameterType = 9
      if ParameterValue > ParameterMax
        ParameterValue = ParameterMax
 	 		end
 	 		k = ParameterValue
 	 		j = 0
 	 		while k > 0
        c = ParameterOptions[j]
	 			j += 1
	 			if c = 0 then goto dploop2
  			if c = ';' then k -= 1
      end
dploop2:
			k = j
			q = 0
dploop3:
			c = ParameterOptions[j]
			j += 1
			Line[q] = c
			if c = 0 then goto dploop4
			if c = ';'
			  Line[q] = 0
			  goto dploop4
			end
			if q < 20 then q += 1
			goto dploop3
dploop4:
      attr = 0
			if Editing > 0 then attr = INVERS
      drawtext(0, 3*FH, Line, attr)
    elseif ParameterType = 13
      drawtext(0, 3*FH, ParameterOptions)
		end
		drawnumber( 5*FW, 7*FH, ParameterValue )
    drawnumber( 10*FW, 7*FH, ParameterMin )
    drawnumber( 15*FW, 7*FH, ParameterMax )
rem	end
return

parseWholeParameter:
rem ParameterBufferIndex contains length of data in ParameterBuffer
    rem uint8_t Parent Parameter Number
    rem uint8_t type and hidden bit
    rem char[] Parameter Name (null terminated)
		
		rem if Type == 9 (select)
		rem char[] options ';' delimited
		rem uint8_t field value = 0
		rem uint8_t minimum allowed value = 0
		rem uint8_t maximum allowed value = 1
		rem uint8_t default value = 0
		rem units (null-terminated string)
  ParameterType = ParameterBuffer[1]
	j = 2
	k = 0
pwploop1:
	c = ParameterBuffer[j]
	ParameterName[k] = c
	j += 1
	k += 1
	if c # 0 then goto pwploop1
  k = 0
	if ParameterType = 9
pwploop2:
    c = ParameterBuffer[j]
    ParameterOptions[k] = c
    j += 1
    k += 1
    if c # 0 then goto pwploop2
    ParameterValue = ParameterBuffer[j]
		OldParameterValue = ParameterValue
    ParameterMin = ParameterBuffer[j+1]
    ParameterMax = ParameterBuffer[j+2]
	elseif ParameterType = 13
    ParameterValue = ParameterBuffer[j]
		j += 2
pwploop3:
    c = ParameterBuffer[j]
    ParameterOptions[k] = c
    j += 1
    k += 1
    if c # 0 then goto pwploop3		 
  end
return

rem                                             5 0 ( - 1 1 7 d b m
rem EA1E2B EAEE010200095061636B65742052617465003530282D31313764626DC3
rem                 ) ; 1 5 0 ( - 1 1 2 d b m ) ; 2 5 0 ( - 1 0 8 d
rem EA1E2B EAEE0101293B313530282D31313264626D293B323530282D31303864F3
rem                 b m ) ; 5 0 0 ( - 1 0 5 d b m)
rem EA1E2B EAEE0100626D293B353030282D31303564626D290003000300487A0021

parseParameterPacket:
    rem # payload format:
    rem --  uint8_t Destination node address
    rem --  uint8_t Device node address
    rem --  uint8_t Parameter Number
    rem --  uint8_t Chunks remaining
    rem --  uint8_t Parent Parameter Number or data if chunk > 0
    rem --  uint8_t type and hidden bit
    rem --  char[] Parameter Name (null terminated)
    rem --  ... depending on type
rem  if ParameterBuffer[2] = ParameterToRead
	 	j = 4
	 	if ParameterChunkIndex = 0
	 	  ParameterBufferIndex = 0
	 	end
    rem copy from byte 4 to end
	 	count -= 4
	 	while count > 0
      ParameterBuffer[ParameterBufferIndex] = receiveBuffer[j]
      ParameterBufferIndex += 1
			if ParameterBufferIndex >238 then ParameterBufferIndex = 238
	 		j += 1
	 		count -= 1			
	 	end
	 	if receiveBuffer[3] > 0
	 	  rem next chunk
	 		ParameterChunkIndex += 1
	 	  gosub readParameter
	 	else
	 	  ReadingParameter = 0
      gosub parseWholeParameter
      ParameterValid = 1
	 		rem parse parameter
	 	end
rem  end
return

updateParameter:
  transmitBuffer[0] = deviceIds[deviceIndex]
  transmitBuffer[1] = 0xEF
  sendCommand = FRAME_SET_PARAMETER
  transmitBuffer[2] = ParameterToRead
  transmitBuffer[3] = ParameterValue
  sendLength = 4
  sendTimeout = 0
  waitForResponse = 0
  gosub sendPacket
return

confirmCommand:
  transmitBuffer[0] = deviceIds[deviceIndex]
  transmitBuffer[1] = 0xEF
  sendCommand = FRAME_SET_PARAMETER
  transmitBuffer[2] = ParameterToRead
  transmitBuffer[3] = 4
  sendLength = 4
  sendTimeout = 0
  waitForResponse = 1
  gosub sendPacket
return

startCommand:
  transmitBuffer[0] = deviceIds[deviceIndex]
  transmitBuffer[1] = 0xEF
  sendCommand = FRAME_SET_PARAMETER
  transmitBuffer[2] = ParameterToRead
  transmitBuffer[3] = 1
  sendLength = 4
  sendTimeout = 0
  waitForResponse = 1
  gosub sendPacket
return

stopCommand:
  transmitBuffer[0] = deviceIds[deviceIndex]
  transmitBuffer[1] = 0xEF
  sendCommand = FRAME_SET_PARAMETER
  transmitBuffer[2] = ParameterToRead
  transmitBuffer[3] = 5
  sendLength = 4
  sendTimeout = 0
  waitForResponse = 1
  gosub sendPacket
return

startReadingParameters:
  ParameterToRead = 1
	ParameterChunkIndex = 0
	ReadingParameter = 1
	gosub readParameter
return

startDeviceSetup:
  state = STATE_DEVICE_SETUP
  parameterIndex = 0
  currentFolder = 0
  gosub startReadingParameters
return

deviceSetupPage:
  gosub displayParameter
  if Event = EVT_EXIT_BREAK
		if ParameterType = 13
			if ParameterValue = 3
        gosub stopCommand
      elseif ParameterValue = 2
        gosub stopCommand
rem      else
rem        state = STATE_DEVICE_LIST
			end
    else
      state = STATE_DEVICE_LIST
		end
  elseif Event = EVT_DOWN_FIRST
		if Editing > 0
      if ParameterValue > ParameterMin then ParameterValue -= 1
    else
			if ParameterToRead < deviceParameterCounts[deviceIndex]
        ParameterToRead += 1
      else
        ParameterToRead = 1
			end
      ParameterChunkIndex = 0
      ReadingParameter = 1
			Editing = 0
	    gosub readParameter
		end
  elseif Event = EVT_UP_FIRST
		if Editing > 0
      if ParameterValue < ParameterMax then ParameterValue += 1
    else
			if ParameterToRead > 1
        ParameterToRead -= 1
      else
        ParameterToRead = deviceParameterCounts[deviceIndex]
			end
      ParameterChunkIndex = 0
      ReadingParameter = 1
			Editing = 0
	    gosub readParameter
		end
  elseif Event = EVT_MENU_BREAK
		if ParameterType = 9		
 	 		if Editing > 0
 	 		  Editing = 0
 	 			if ( OldParameterValue # ParameterValue )
 	 			  gosub updateParameter
 	 			end
 	 		else
 	 		  Editing = 1
 	 		end		  
		elseif ParameterType = 13
			if ParameterValue # 0
			  if ParameterValue = 3
			    gosub confirmCommand
        else
			    gosub stopCommand
				end
			else
			  gosub startCommand
		  end
	  end
  end
return

deviceListPage:
  if Event = EVT_EXIT_BREAK
    goto exit
  elseif (Event = EVT_DOWN_FIRST) | (Event = EVT_DOWN_REPT)
    if deviceIndex < deviceCount-1 then deviceIndex += 1
rem        gosub nextDevice
  elseif (Event = EVT_UP_FIRST) | (Event = EVT_UP_REPT)
    if deviceIndex > 0 then deviceIndex -= 1
rem        gosub previousDevice
  elseif Event = EVT_MENU_BREAK
		if deviceParameterCounts[deviceIndex] > 0
      state = STATE_DEVICE_SETUP
      gosub startDeviceSetup
		end
  end

  drawtext(0, 0, "ELRS SETUP V1.02", INVERS)

  if deviceCount > 0
    i = 0

    while i < deviceCount
      attr = 0
      if i = deviceIndex then attr = INVERS

      nameOffset = kMaxDeviceNameLength * i

      drawtext(0, i * FH + FH, deviceNames[nameOffset], attr)

      drawnumber( 21*FW, i * FH + FH, deviceParameterCounts[i] )

      drawnumber( 5*FW, 6 * FH, deviceIndex )
      drawnumber( 10*FW, 6 * FH, deviceIds[deviceIndex] )

      i += 1
    end
  else
    drawtext(0, 3*FH, "Waiting for devices..")
  end
return

main:
  time = gettime()
  gosub checkForPackets

  drawclear()
  if state = STATE_DEVICE_LIST
    gosub deviceListPage
  elseif state = STATE_DEVICE_SETUP
    gosub deviceSetupPage

rem    elseif state = STATE_RUN_COMMAND
rem        gosub runCommandPage
  end

rem  gosub sendNextPacket
stop

exit:
finish

